import java.util.*;
import java.util.stream.IntStream;

class proximitySensor extends sensor implements collidableObject{
	double range;
	byte complexity = 1;

	public proximitySensor(pose sensorPose, pose basePose, double range) {
		super(sensorPose,basePose);		
		samples = new ArrayList<Double>();
		this.range = range;
	}

	public proximitySensor(pose sensorPose, double range) {
		this(sensorPose,(pose)null,range);
	}


	public proximitySensor(double x, double y, double theta, pose basePose, double range) {
		this(new pose(x,y,theta),basePose,range);		
	}

	public proximitySensor(double x, double y, double theta, double range) {
		this(new pose(x,y,theta),(pose)null,range);	
	}

	public proximitySensor(double range) {
		samples = new ArrayList<Double>();
		this.range = range;
	}

	public boolean checkCollision(collidableObject obj) {
		samples.clear();
		boolean collided = false;

		if (obj instanceof Maze) {
			Maze m = (Maze) obj;
			point2D checkingPoint = new point2D();
			
			// To be coded
			// This method is used for doing the sensing


			if (samples.isEmpty())
				samples.add((double)-1);
		}

		return collided;
	}

	public byte getComplexity() {
		return complexity;
	}

	public void setCollisionState(boolean inState) {
		if (inState)
			samples.add((double)range+1);
		else
			samples.add((double)-1);
	}
}